{ 
  , ।祭  ⥭ BMP ⨭  䠩.
  ন 16-梥 ⨭  ᦠ
}
Unit bmp;

interface

Procedure BMPDisplay(const FileName: String);

implementation

Uses Graph;

Type
 TBitMapHeader =
  Record
   bfType :             Word;        { ⪠ 䠩 BM }
   bfSize :             LongInt;     {  䠩   }
   bfReserved :         LongInt;     { ࢭ   = 0 }
   bfOffBits :          LongInt;     { 饭   }
   biSize :             LongInt;     {  BITMAP_INFO  }
   biWidth :            LongInt;     { ਭ ࠦ  ᥫ }
   biHeight :           LongInt;     {  ࠦ  ᥫ }
   biPlanes :           Word;        { ⮢ ᪮ = 1 }
   biBitCount :         Word;        { ⢮ ⮢  ᥫ 1,4,8,24 }
   biCompression :      LongInt;     {  ᦠ  }
   biSizeImage :        LongInt;     {  ࠦ   }
   biXPelsPerMeter :    LongInt;     { 襭  ਧ⠫ }
   biYPelsPerMeter :    LongInt;     { 襭  ⨪ }
   biClrUsed :          LongInt;     { ⢮ ᯮ㥬 梥⮢ }
   biClrImportant :     LongInt;     { ⢮ ᭮ 梥⮢ }
  End;

 TRGBQuad =                   { ᠭ 梥 }
  Record
   rgbBlue,                   { ⥭ᨢ 㡮 }
   rgbGreen,                  { ⥭ᨢ  }
   rgbRed,                    { ⥭ᨢ ᭮ }
   rgbReserved :        Byte; { ࢭ }
  End;

Type TByteArray = Array[0..50000] of byte;

Procedure Display1 (Var f : File; const BitMapHeader : TBitMapHeader);
Begin
 WriteLn ('஬ ०  ন.');
End;

Procedure Display4 (Var f : File; const BitMapHeader : TBitMapHeader);
Var i,j : Integer;
Var RGBQuad : TRGBQuad;
Var TwoPixel : Byte;
Var Black : Byte;
Var Line : ^TByteArray;
Var number : Word;
Var BeginX,BeginY,EndY : Integer;
    CurrentX: Integer;
Begin
 If GetMaxColor < 15 then
  Begin
   WriteLn ('  ०  ⮡ࠦ 16 梥⮢.');
   Exit;
  End;

 Black := 16;
 With BitMapHeader do
  begin
   For i:= 0 to 15 do         { ⥭    }
    Begin
     BlockRead(f,RGBQuad,SizeOf(RGBQuad));
     If (LongInt(RGBQuad)=0) then Black := i;
     With RGBQuad do
      SetRGBPalette(i, rgbRed shr 2, rgbGreen shr 2, rgbBlue shr 2);
     SetPalette(i,i);
    End;

   Number := (biWidth div 2 + 3) and not 3;  {   ப   }
   BeginX := (GetMaxX - biWidth) div 2;
   BeginY := GetMaxY - (GetMaxY - biHeight) div 2;
   EndY := BeginY+1-biHeight;
  End;

 GetMem (Line,number+1);          { 뢮 ࠦ }
 For j:=BeginY downto EndY do
  Begin
   BlockRead(f,Line^[1],number);
   CurrentX := BeginX;
   For i:=1 to number do
    Begin
     TwoPixel := Line^[i];
     If TwoPixel shr 4 <> Black then {  梥 ⠥ ஧ }
      PutPixel(CurrentX,j,TwoPixel shr 4);
     Inc(CurrentX);
     If TwoPixel and 15 <> Black then
      PutPixel(CurrentX,j,TwoPixel and 15);
     Inc(CurrentX);
    End;
  End;
 FreeMem (Line,number+1);
End;

Procedure Display8 (Var f : File; const BitMapHeader : TBitMapHeader);
Begin
 WriteLn (' 256 梥⮢  ন.');
End;

Procedure Display24 (Var f : File; const BitMapHeader : TBitMapHeader);
Begin
 WriteLn (' 24 ⭮ 梥  ন.');
End;

Procedure BMPDisplay(const FileName: String);
Var f: File;
    BitMapHeader : TBitMapHeader;
Begin
 Assign(f,FileName);
 {$I-}
 FileMode:=0;  { 뢠 䠩  ⥭ }
 Reset(f,1);
 {$I+}

 If IOResult<>0 Then
  Begin
   WriteLn (' ⠪ 䠩.');
   Exit;
  End;

 BlockRead(f,BitMapHeader,SizeOf(BitMapHeader));
 With BitMapHeader do
  Begin
   If (bfType<>19778) or (bfReserved<>0) or (biPlanes<>1) then
    Begin
     WriteLn (' ଠ BMP 䠩.');
     Close(f);
     Exit;
    End;
   If biCompression<>0 Then
    Begin
     WriteLn (' ࠭  ᦠ⨥ .');
     Close(f);
     Exit;
    End;
   ClearDevice;
   Case biBitCount of
    1  : Display1  (f, BitMapHeader);
    4  : Display4  (f, BitMapHeader);
    8  : Display8  (f, BitMapHeader);
    24 : Display24 (f, BitMapHeader);
   else
    Begin
     WriteLn (' ଠ BMP 䠩.');
     Close(f);
     Exit;
    End;
   End;
  End;
 Close(f);
End;
End.

