Program realdelay;
Uses crt,dos;
var
 timetick,period:integer;
 enablecount:boolean;
 oldint1ch:pointer;

Procedure ResetTimer;
Const counter:word=1193;
begin
  Port[$43]:=$36;
  Port[$40]:=Lo(Counter);
  Port[$40]:=Hi(Counter);
  enablecount:=true;
  timetick:=0;
  period:=0;
end;

Procedure RestoreTimer;
Const counter:word=65535;
begin
  Port[$43]:=$36;
  Port[$40]:=Lo(Counter);
  Port[$40]:=Hi(Counter);
  enablecount:=false;
end;

Procedure Mydelay(delaytime:longint);
Type
  Dltm=Record
	 case boolean of
	 true:(long:longint);
	 false:(low,high:word);
       end;
 var
 dltime:dltm;
 regs:registers;
 begin
   with dltime do
   begin
     long:=delaytime*1000;
     regs.ah:=$86;
     regs.cx:=high;
     regs.dx:=low;
     intr($15,regs);
   end;
end;

Procedure ClockInt;interrupt;
begin
  if enablecount then
  begin
  inc(timetick);
  if timetick=1000 then
  begin
    inc(period);
    timetick:=0;
  end;
inline($FF/$1E/>oldint1ch);
end;
end;

begin
  clrscr;
  getintvec($1c,oldint1ch);
  setintvec($1c,@clockint);
  resettimer;
  mydelay(10000);
  restoretimer;
  setintvec($1c,oldint1ch);
end.
